<script context="module">
    export async function preload({ params }) {
        return { id: +params.id }
    }
</script>

<script>
    import { beforeUpdate } from 'svelte'
    import { timeline } from 'lib/timeline'
    import { get } from 'lib/fetch'
    import { postId } from 'store'
    import Header from 'components/Header.svelte'
    import Post from 'components/Post/Post.svelte'

    export let id

    let post
    let mutationObserver
    let container

    const init = () => {
        mutationObserver = new MutationObserver(mutationsList => {
            // On regarde les mutations qui ont été effectuées
            for (let mutation of mutationsList) {
                // On ne récupère que l'ajout de nouveaux éléments
                if (mutation.type === 'childList') {
                    // Si le noeud ajouté possède la fonction `scrollIntoView`, appellons la
                    if (
                        mutation.addedNodes.length &&
                        mutation.addedNodes[0]?.scrollIntoView
                    ) {
                        mutation.addedNodes[0]?.scrollIntoView()
                    }
                }
            }
        })
    }

    // Utilisation de la méthode beforeUpdate du cycle de vie
    // Cette méthode est appelée à chaque fois les props sont mises à jour
    beforeUpdate(async () => {
        // On vérifie si nous avons changé de page ou que `$postId` est undefined
        const fetchPost = id !== +$postId

        // On déconnecte l'observer avant de faire nos appels API
        if (fetchPost && mutationObserver) {
            mutationObserver.disconnect()
        }

        // On récupère le post, s'il éxiste, dans la timeline
        timeline.subscribe(posts => {
            post = posts.find(p => +p.id === id)
        })
        $postId = id
        if (fetchPost) {
            // On récupère la dernière version du post depuis l'API
            const { req, res } = await get(`/api/posts/${id}`)
            if (req.ok) {
                // On met à jour la timeline avec le pst fraichement récupéré
                timeline.update(posts => {
                    if (post === undefined) {
                        return [...posts, res]
                    }
                    return posts.map(p => (+p.id === +res.id ? res : p))
                })
            }
        }

        // Promesse qui attends la résolution de tous les changements d'états en cours
        await tick()

        // On reconnecte l'observer à notre container
        if (container) {
            mutationObserver.observe(container, { childList: true })
        }
    })
</script>

<Header withBackLink>Post</Header>

<section bind:this={container} use:init>
    {#if post}
        {#if post.parent}
            <Post post={post.parent} showParentLink={false} />
        {/if}
        <Post {post} focus showParentLink={false} />
        {#if post?.answers?.length > 0}
            {#each post?.answers as answer}
                <Post post={answer} showParentLink={false} />
            {/each}
        {:else}
            <p>Aucune réponse pour l'instant</p>
        {/if}
    {/if}
</section>

<style lang="postcss">
    p {
        @apply text-blueGray-500 text-center mt-4;
    }
</style>
